#!/bin/bash

#Exportacion de programas necesarios
export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/
export PATH=/cursos/BI/bin/exonerate/i386/bin:$PATH
export PATH=/cursos/BI/bin:$PATH
export WISECONFIGDIR=/cursos/BI/soft/wise-2.2.0/wisecfg
export PATH=/cursos/BI/bin/netblast/bin:$PATH

#Consideraciones
echo "."
echo "."
echo "AutoSEL v3.3-BETA-"
echo "BUG en traduccion, solo seleccionable las frames de la hebra guia"
echo "."
echo "Desarrollado por el grupo 3B - BioinformaticTEAM"
echo "." 
echo "."
echo "INSTRUCCIONES"
echo "¡SOBRE TODO! Si tu selenoproteina contiene una U, cambiala por X"
echo "Por defecto, se cogen 20000 nucleotidos de margen. Cambios son notificados"
echo "Cuando aparezca el output del exonerate, debes mirar cuantos exones quieres extraer"
echo "En ocasiones, si el alineamiento es malo el exonerate no se realiza, se indicara que queremos 0 exones"
echo "Si al no encontrar buenos hits no se incluye el valor, quiere decir que no hay ninguno"
echo "Para seleccionar frame se muestran las 6 posibilidades, solo seleccionables las 3 ultimas. Para la reversa, se debera hacer a mano"
echo "En la carpeta t_coffees se incluyen los alineamientos individuales y un multialineamiento"
echo "." 
echo "."

#Selección de query
echo "Introduce el nombre de tu query: (Solo el nombre, no pongas el .fa )"
read query
echo "."
echo "."

#Carpetas organizadoras
mkdir blast.coordenadas
mkdir blast.alineamiento
mkdir regiones.genomicas
mkdir output.exonerate
mkdir exones
mkdir cDNAs
mkdir proteins
mkdir t_coffees

#Proceso
    for genome in F.cylindrus P.capsici A.laibachii_Nc14 G.niphandrodes I.multifiliis_strain_G5 S.arctica P.polycephalum D.fasciculatum D.discoideum_AX4 L.donovani_BPK282A1 L.tarentolae T.congolense C.fasciculata A.rara;

do {

echo "Procesando $genome"
echo "Blasteando..."

blastdb=`grep $genome /cursos/BI/genomes/protists/genomes_list_and_info.tab | cut -f 4`
blastall -F f -p tblastn -i $query.fa -d $blastdb -o $query.CONTRA$genome.tblastn -m 9
blastall -F f -p tblastn -i $query.fa -d $blastdb -o $query.CONTRA$genome.alineamiento.tblastn

sed '1,4d' $query.CONTRA$genome.tblastn > corte$genome

menor=`cut -f 11 corte$genome | head -1 | fold -1 | egrep -w - | wc -w`

if [ $menor -eq 0 ]
then 
echo "No hay hits menores que 0. El mejor es de `cut -f 11 corte$genome | head -1`"
echo "."
echo "."
echo "Pulsa INTRO para continuar"
read continuar
echo "."
echo "."
mv $query.CONTRA$genome.tblastn ./blast.coordenadas
mv $query.CONTRA$genome.alineamiento.tblastn ./blast.alineamiento

rm corte$genome

else
evalue=`cut -f 11 corte$genome | head -1`
echo "E-value asignado como mejor de `cut -f 11 corte$genome | head -1`"
echo "Hit posicionado en `cut -f 2 corte$genome | head -1`" 

echo "Extrayendo región..."
fastaindex $blastdb index$genome.index
fastafetch $blastdb index$genome.index "`cut -f 2 corte$genome | head -1`" > nomseq$genome.fa

rm index$genome.index

mv $query.CONTRA$genome.tblastn ./blast.coordenadas
mv $query.CONTRA$genome.alineamiento.tblastn ./blast.alineamiento

cp nomseq$genome.fa 1
longitud=`sed '1d' 1 | fold -1 | wc -w`
rm 1

hitstart=`cut -f 9 corte$genome | head -1` 
hitend=`cut -f 10 corte$genome | head -1`

   if [ $hitstart -gt $hitend ]
      then
      echo "REVERSE"
      echo "El hit empieza en la posición $hitstart y acaba en $hitend"
      hitstart=$hitend
      hitend=`cut -f 9 corte$genome | head -1`

      else
      echo "El hit empieza en la posición $hitstart y acaba en $hitend"
      fi

start=`expr $hitstart - 10000`

   if [ $start -lt 0 ]
      then
      echo "Margen upstream de $hitstart nucleotidos" 
      start=1
      fi

length=20000;
comprobar=`expr $start + 20000`

   if [ $comprobar -gt $longitud ]
      then 
      margendown=`expr $longitud - $hitend`
      echo "Margen downstream de $margendown nucleotidos"
      length=`expr $longitud - $start`
      fi

fastasubseq nomseq$genome.fa $start $length > genomic$genome.fa

rm corte*
rm nomseq*

echo "Prediciendo estructura génica..."

echo "Evalue de $evalue, prefieres un exonerate exhaustivo? (si=1/no=0)"
read exhaustivo

if [ $exhaustivo -eq 1 ]
   then 
   exonerate -m p2g --showtargetgff -q $query.fa -t genomic$genome.fa --exhaustive yes > exonerate.$query.$genome.gff
   cat exonerate.$query.$genome.gff
   echo "Extrayendo exones..."
   egrep -w exon exonerate.$query.$genome.gff > exon.$query.$genome.gff
   mv exonerate.$query.$genome.gff ./output.exonerate
   
   else
   exonerate -m p2g --showtargetgff -q $query.fa -t genomic$genome.fa > exonerate.$query.$genome.gff
   cat exonerate.$query.$genome.gff
   echo "Extrayendo exones..."
   egrep -w exon exonerate.$query.$genome.gff > exon.$query.$genome.gff
   mv exonerate.$query.$genome.gff ./output.exonerate

   fi

echo "Escoge cuantos exones quieres extraer... (0 indica que no hay ninguno)"
read cuantos

if [ $cuantos -eq 0 ]
   then
   echo "No tienes exones, finalizando..."
   mv genomic$genome.fa ./regiones.genomicas
   mv exon.$query.$genome.gff ./exones

   else
   echo "Convirtiendo a cDNA..."
   head -$cuantos exon.$query.$genome.gff > buenexon.$query.$genome.gff

   fastaseqfromGFF.pl genomic$genome.fa buenexon.$query.$genome.gff > cDNA.$query.$genome.fa
   
   rm buenexon.$query.$genome.gff
   mv genomic$genome.fa ./regiones.genomicas
   mv exon.$query.$genome.gff ./exones
   
   echo "Traduciendo..."
    
   fastatranslate -f cDNA.$query.$genome.fa > muestra.fa
   cat muestra.fa
   rm muestra.fa

   echo "Selecciona la frame adecuada (OJO, solo puedes seleccionar las 3 directas) (1-3):"
   read frame
   
   fastatranslate -f cDNA.$query.$genome.fa -F $frame > protein.$query.$genome.fa
   mv cDNA.$query.$genome.fa ./cDNAs

   t_coffee protein.$query.$genome.fa $query.fa > t_coffee.$query.$genome
   mv t_coffee.$query.$genome ./t_coffees
   mv protein.$query.$genome.fa ./proteins
   mv protein.$query.$genome.* ./t_coffees
   
   fi

echo "Hecho"
echo "."
echo "."

echo "Pulsa INTRO para continuar"
read continuar

fi

} done 

cat ./proteins/protein.$query.* > proteins.$query.MSA.fa
cat $query.fa >> proteins.$query.MSA.fa

t_coffee proteins.$query.MSA.fa > t_coffee.$query.MSA
mv t_coffee.$query.MSA ./t_coffees
mv proteins.$query.MSA.* ./t_coffees

mkdir resultados.$query

mv blast.* ./resultados.$query
mv regiones.genomicas ./resultados.$query
mv output.exonerate ./resultados.$query
mv exones ./resultados.$query
mv cDNAs ./resultados.$query
mv proteins ./resultados.$query
mv t_coffees ./resultados.$query

